#!/usr/bin/python

# This needs to be made a hell of a lot smarter, but its a start.
# Right now, we can only do a list of milestones in the same series.
# The for name in names loop below should be rewritten at some point
# to work with milestones of different series no matter what order
# they are entered.

# If you do multiple milestones from a series, you have to enter them
# in order from lowest to highest, also if you're working with -alpha,
# etc., milestones, then you need to make sure that you give it .0
# milestone and that that milestone already exists.  This script will
# then make the \d.\d.1 milestone for you.

# I also want to modularize all this so I can later use it in
# more/larger projects, like a cutom bug management GUI for Launchpad.

import sys
import re
from launchpadlib.launchpad import Launchpad

lp = Launchpad.login_with('eg_bugs', 'staging')

project = lp.projects["evergreen"]

names = sys.argv[1:]

# Global so we don't recompile every time through the loop:
vpat = re.compile('^(\d+)\.(\d+)\.(\d+)$')

# Made a bit more generic than we need here with an eye toward moving
# it to module so we can use it elsewhere, later.
def getNewVersion(version, which):
    global vpat
    newV = None
    m = vpat.match(name)
    if m:
        major, p1, minor, p2, patch  = m.group()
        if which == 'major':
            major = int(major) + 1
        elif which == 'minor':
            minor = int(minor) +1
        elif which == 'patch':
            patch = int(patch) + 1
        newV = '%d.%d.%d' % (int(major), int(minor), int(patch))
    return newV

open_bugs = list()
committed_bugs = list()
newMstone = None

for name in names:
    mstone = project.getMilestone(name=name)
    if mstone:
        open_bugs.append(mstone.searchTasks(status = [
                'New',
                'Incomplete',
                'Triaged',
                'Confirmed',
                'In Progress']))
        commited_bugs.append(mstone.searchTasks(status = 'Fix Committed'))
        if mstone.is_active:
            mstone.is_active = False
            mstone.lp_save
        newVersion = getNewVersion(name, 'patch')
        if newVersion:
            series_name = mstone.series_target.name
            matching_series = [series for series in project.series
                               if series.name == series_name]
            series = matching_series[0]
            matching_milestones = [stone for stone in series.active_milestones
                       if stone.name == newVersion]
            if len(matching_milestones):
                newMstone = matching_milestones[0]
            else:
                newMstone = series.newMilestone(name=newVersion)

if newMstone:
    for bug in committed_bugs:
        bug.status = 'Fix Released'
        bug.lp_save
    for bug in open_bugs:
        bug.milestone = newMstone
        bug.lp_save
else:
    print 'No milestone for ' + newVersion



